servo/models/__init__.py
# -*- coding: utf-8 -*-

from .common import *
from .product import *
from .account import *
from .queue import *
from .customer import *
from .device import *
from .note import *
from .order import *
from .invoices import *
from .purchases import *
from .shipments import *
from .parts import *
from .repair import *
from .escalations import *
from .rules import *

servo/models/purchases.py
# -*- coding: utf-8 -*-

from django.db import models
from django.conf import settings
from django.utils import timezone
from django.utils.translation import ugettext_lazy as _

from django.dispatch import receiver
from django.db.models.signals import post_save

from servo import defaults
from servo.models.common import Location, Configuration
from servo.models.product import Product, Inventory
from servo.models.order import Order, AbstractOrderItem, ServiceOrderItem


class PurchaseOrder(models.Model):
    """
    A purchase order(PO) consists of different purchase order items
    all of which may reference individual Service Orders.
    When a PO is submitted, the included items are registered
    to the /products/incoming/ list (items that have not yet arrived).
    A PO cannot be edited after it's been submitted.

    Creating a PO from an SO only creates the PO, it does not submit it.
    """
    location = models.ForeignKey(
        Location,
        editable=False,
        null=True,
        on_delete=models.SET_NULL,
        help_text=_('The location from which this PO was created')
    )
    sales_order = models.ForeignKey(Order, null=True, editable=False, on_delete=models.SET_NULL)
    reference = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Reference"),
    )
    confirmation = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Confirmation"),
    )

    created_by = models.ForeignKey(settings.AUTH_USER_MODEL,
        editable=False,
        null=True,
        on_delete=models.SET_NULL)
    created_at = models.DateTimeField(auto_now_add=True, editable=False)
    submitted_at = models.DateTimeField(null=True, editable=False)

    supplier = models.CharField(
        blank=True,
        max_length=32,
        verbose_name=_("Supplier")
    )
    carrier = models.CharField(
        blank=True,
        max_length=32,
        verbose_name=_("Carrier")
    )
    tracking_id = models.CharField(
        blank=True,
        max_length=128,
        verbose_name=_("Tracking ID")
    )
    days_delivered = models.IntegerField(
        blank=True,
        default=1,
        verbose_name=_("Delivery Time")
    )

    has_arrived = models.BooleanField(default=False)
    total = models.FloatField(null=True, editable=False)
    invoice_id = models.CharField(default='', max_length=10, editable=False)
    invoice = models.FileField(
        null=True,
        editable=False,
        upload_to="gsx_invoices",
        help_text="Apple's sales invoice for this PO"
    )

    def only_apple_parts(self):
        """
        Returns True if PO contains only Apple parts
        Useful for Stocking Orders
        """
        for p in self.purchaseorderitem_set.all():
            if not p.product.is_apple_part:
                return False

        return True

    @property
    def is_editable(self):
        return self.submitted_at is None

    def can_create_gsx_stock(self):
        return self.is_editable and self.confirmation == ''

    def order_items(self, items):
        pass

    def get_absolute_url(self):
        from django.urls import reverse
        if self.submitted_at:
            return reverse("purchases-view_po", args=[self.pk])

        return reverse("purchases-edit_po", args=[self.pk])

    def sum(self):
        total = 0
        for p in self.purchaseorderitem_set.all():
            total += float(p.price*p.amount)

        return total

    def amount(self):
        amount = 0
        for p in self.purchaseorderitem_set.all():
            amount += p.amount

        return amount

    def submit(self, user):
        """
        Submits this Purchase Order
        """
        if self.submitted_at is not None:
            raise ValueError(_("Purchase Order %d has already been submitted") % self.pk)

        location = user.get_location()

        for i in self.purchaseorderitem_set.all():
            inventory = Inventory.objects.get_or_create(location=location,
                                                        product=i.product)[0]
            inventory.amount_ordered += i.amount
            inventory.save()
            i.ordered_at = timezone.now()
            i.save()

        self.submitted_at = timezone.now()
        self.save()

    def cancel(self):
        """
        Cancels this Purchase Order
        Declined Repairs etc
        """
        location = self.created_by.get_location()

        for i in self.purchaseorderitem_set.all():
            inventory = Inventory.objects.get(location=location, product=i.product)
            inventory.amount_ordered -= i.amount
            inventory.save()
            i.expected_ship_date = None
            i.save()

    def add_product(self, product, amount, user):
        """
        Adds a product to this Purchase Order
        """
        poi = PurchaseOrderItem(amount=amount, purchase_order=self)
        poi.created_by = user
        # adding from a Service Order
        if isinstance(product, AbstractOrderItem):
            poi.code = product.product.code
            poi.order_item = product
            poi.price = product.price
            poi.product_id = product.product.id
            poi.title = product.product.title
        # adding from Stock
        if isinstance(product, Product):
            poi.code = product.code
            poi.title = product.title
            poi.product_id = product.id
            poi.price = product.price_purchase_stock

        poi.save()

    def delete(self, *args, **kwargs):
        if self.submitted_at:
            raise ValueError(_('Submitted orders cannot be deleted'))

        return super(PurchaseOrder, self).delete(*args, **kwargs)

    class Meta:
        ordering = ('-id',)
        app_label = 'servo'


class PurchaseOrderItem(AbstractOrderItem):
    """
    A line item on a Purchase Order
    """
    price = models.DecimalField(
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Purchase Price"),
        help_text=_("Purchase price without taxes")
    )

    purchase_order = models.ForeignKey(
        PurchaseOrder,
        editable=False,
        on_delete=models.CASCADE,
        verbose_name=_("Purchase Order")
    )

    # begin optimization
    sales_order = models.ForeignKey(
        Order,
        null=True,
        editable=False,
        on_delete=models.SET_NULL,
    )

    sales_order_ref = models.CharField(
        default='',
        max_length=8,
        editable=False,
    )

    purchase_order_ref = models.CharField(
        default='',
        max_length=32,
        editable=False,
    )

    user_fullname = models.CharField(
        default='',
        max_length=256,
        editable=False,
    )
    # /end optimization

    order_item = models.ForeignKey(ServiceOrderItem,
        null=True, editable=False, on_delete=models.SET_NULL)
    reference  = models.CharField(default='', blank=True, max_length=128)
    ordered_at = models.DateTimeField(null=True, editable=False)

    expected_ship_date = models.DateField(null=True, editable=False)
    received_at = models.DateTimeField(
        null=True,
        blank=True,
        editable=False,
        verbose_name=_("arrived")
    )

    received_by = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        null=True,
        editable=False,
        related_name='+',
        on_delete=models.SET_NULL,
    )

    @classmethod
    def from_soi(cls, po, soi, user):
        """
        Creates a new POI from a Sales Order item
        """
        poi = cls(purchase_order=po, order_item=soi)
        poi.code = soi.code
        poi.title = soi.title
        poi.created_by = user

        poi.price = soi.get_purchase_price()
        poi.product = soi.product

        return poi

    def get_incoming_url(self):
        """
        Returns the correct URL to receive this item
        """
        if self.received_at is None:
            date = "0000-00-00"
        else:
            date = self.received_at.strftime("%Y-%m-%d")

        return "/sales/shipments/incoming/%s/%d/" % (date, self.pk)

    def receive(self, user):
        if self.received_at is not None:
            raise ValueError(_("Product has already been received"))
        self.received_at = timezone.now()
        self.received_by = user
        self.save()

    def save(self, *args, **kwargs):
        # The following four fields are used so much
        # that we store them for fast access
        if self.sales_order is None:
            self.sales_order = self.purchase_order.sales_order

        if self.sales_order_ref == '' and self.sales_order:
            self.sales_order_ref = self.sales_order.code

        if self.purchase_order_ref == '':
            self.purchase_order_ref = self.purchase_order.reference

        if self.user_fullname == '':
            user = self.created_by or self.purchase_order.created_by
            self.user_fullname = user.get_name()

        super(PurchaseOrderItem, self).save(*args, **kwargs)

        # Sync SOI and POI serial numbers
        if self.order_item:
            if self.order_item.sn and not self.sn:
                self.sn = self.order_item.sn
            else:
                self.order_item.sn = self.sn

            self.order_item.save()

    def __str__(self):
        return self.code

    class Meta:
        ordering = ('id',)
        app_label = 'servo'
        get_latest_by = 'id'


@receiver(post_save, sender=PurchaseOrderItem)
def trigger_product_received(sender, instance, created, **kwargs):

    if instance.received_at is None:
        return

    product = instance.product
    po = instance.purchase_order
    location = po.created_by.get_location()

    inventory = Inventory.objects.get_or_create(location=location, product=product)[0]

    # Receiving an incoming item
    if Configuration.track_inventory():
        try:
            inventory.amount_ordered -= instance.amount

servo/forms/__init__.py
# -*- coding: utf-8 -*-

from .base import *
from .orders import *
from .notes import *
from .devices import *
from .product import *
from .repairs import *
from .checkin import *

servo/forms/account.py
# -*- coding: utf-8 -*-

from django import forms
from django.utils.translation import ugettext_lazy as _

from servo.forms.base import BaseForm, BaseModelForm
from servo.models.account import User


class ProfileForm(BaseModelForm):
    # User Profile form for users
    class Meta:
        model = User
        fields = (
            "location",
            "photo",
            "locale",
            "queues",
            "region",
            "timezone",
            "should_notify",
            "notify_by_email",
            "autoprint",
            "tech_id",
            "gsx_userid",
            "gsx_poprefix",
        )
        widgets = {
            'queues': forms.CheckboxSelectMultiple
        }
        
    password1 = forms.CharField(widget=forms.PasswordInput,
                                required=False,
                                label=_("Password"))
    password2 = forms.CharField(widget=forms.PasswordInput,
                                required=False,
                                label=_("Confirmation"))

    def clean(self):
        cd = super(ProfileForm, self).clean()

        if cd.get('gsx_password') == "":
            del(cd['gsx_password'])

        cd['tech_id'] = cd['tech_id'].upper()

        if cd.get('password1'):
            if cd['password1'] != cd['password2']:
                raise forms.ValidationError(_("Password and confirmation do not match!"))

        return cd

    def clean_photo(self):
        MAX_FILESIZE = 1*1024*1024 # 1 MB
        from django.template.defaultfilters import filesizeformat
        photo = self.cleaned_data.get('photo')
        if photo and photo.size > MAX_FILESIZE:
            size = filesizeformat(MAX_FILESIZE)
            error = _('Profile picture should be no larger than %s') % size
            raise forms.ValidationError(error)

        return photo


class RegistrationForm(BaseForm):
    first_name = forms.CharField(label=_("First Name"))
    last_name = forms.CharField(label=_("Last Name"))
    email = forms.EmailField(label=_("Email Address"))
    password = forms.CharField(widget=forms.PasswordInput, label=_("Password"))


class LoginForm(BaseForm):
    username = forms.CharField(
        widget=forms.TextInput(attrs={'placeholder': _('Username')})
    )
    password = forms.CharField(
        widget=forms.PasswordInput(attrs={'placeholder': _('Password')})
    )

servo/forms/base.py
# -*- coding: utf-8 -*-

import json
from django import forms
from django.forms.utils import flatatt
from django.utils.html import format_html
from django.utils.safestring import mark_safe


class NullCharField(forms.CharField):
    def clean(self, value):
        cleaned = super(NullCharField, self).clean(value)
        return cleaned if len(cleaned) else None


class FullTextArea(forms.CharField):
    widget = forms.Textarea(attrs={'class': 'span12'})


class SearchField(forms.CharField):
    widget = forms.TextInput(attrs={
        'class': 'search-query',
        'autocomplete': 'off',
        'placeholder': '',
    })


class ChoiceField(forms.ChoiceField):
    def __init__(self, *args, **kwargs):
        super(ChoiceField, self).__init__(*args, **kwargs)
        self.widget.attrs['class'] = 'span12'


class TextInput(forms.TextInput):
    def __init__(self, *args, **kwargs):
        super(TextInput, self).__init__(*args, **kwargs)
        self.attrs['class'] = 'span12'


class AutocompleteCharField(forms.CharField):
    widget = forms.TextInput(attrs={
        'class': "input typeahead",
        'data-provide': "typeahead"
    })

    def __init__(self, values, *args, **kwargs):
        super(AutocompleteCharField, self).__init__(*args, **kwargs)

        if not type(values) is str:
            values = json.dumps(list(values))

        self.widget.attrs['data-source'] = values


class AutocompleteTextarea(forms.Textarea):
    def __init__(self, rows=8, choices=None):
        super(AutocompleteTextarea, self).__init__()
        self.attrs = {
            'rows': rows,
            'class': "span12 autocomplete",
            'data-source': json.dumps(choices)
        }


class BaseForm(forms.Form):
    required_css_class = "required"


class BaseModelForm(forms.ModelForm):
    required_css_class = "required"


class SearchFieldInput(forms.TextInput):

    def render(self, name, value, attrs=None, **kwargs):
        field = super(SearchFieldInput, self).render(name, value, attrs)
        final_attrs = self.build_attrs(attrs)

        output = format_html(u'''
         <div class="input-group">
            {1}
             <span class="input-group-btn">
                <button class="btn btn-default" type="button"><i class="glyphicon glyphicon-search"></i></button>
            </span>
        </div>
        ''', flatatt(final_attrs), field)

        return mark_safe(output)


class DatepickerInput(forms.DateInput):
    def __init__(self, *args, **kwargs):
        kwargs['format'] = "%Y-%m-%d"
        super(DatepickerInput, self).__init__(*args, **kwargs)

    def render(self, name, value, attrs=None, renderer=None):

        date_format = "yyyy-MM-dd"

        if "format" not in self.attrs:
            attrs['format'] = date_format

        if "data-format" not in self.attrs:
            attrs['data-format'] = date_format

        field = super(DatepickerInput, self).render(name, value, attrs)
        final_attrs = self.build_attrs(attrs)

        output = format_html(u'''
         <div class="input-append date datepicker" data-provide="datepicker" {0}>
            {1}
            <span class="add-on">
                <i data-time-icon="icon-time" data-date-icon="icon-calendar"></i>
            </span>
        </div>
        ''', flatatt(final_attrs), field)

        return mark_safe(output)


class DateTimePickerInput(forms.DateTimeInput):
    def __init__(self, *args, **kwargs):
        kwargs['format'] = "%Y-%m-%d %H:%M"
        super(DateTimePickerInput, self).__init__(*args, **kwargs)

    def render(self, name, value, attrs=None):

        date_format = "yyyy-MM-dd hh:mm"

        if "data-format" not in self.attrs:
            attrs['data-format'] = date_format
        if "class" not in self.attrs:
            attrs['class'] = 'input-medium'

        field = super(DateTimePickerInput, self).render(name, value, attrs)
        final_attrs = self.build_attrs(attrs)

        output = format_html(u'''
         <div class="input-append date datetimepicker" {0}>
            {1}
            <span class="add-on">
                <i data-time-icon="icon-time" data-date-icon="icon-calendar"></i>
            </span>
        </div>
        ''', flatatt(final_attrs), field)

        return mark_safe(output)

servo/templates/purchases/edit_po.html
{% extends "purchases/list_pos.html" %}
{% load servo_tags %}
{% load i18n %}

{% block toolbar %}
    <a class="btn" href="{% url 'purchases-choose_for_po' order.pk %}" data-modal="#modal"><i class="icon-shopping-cart"></i> {% trans "Add Product" %}</a>
{% endblock toolbar %}

{% block filter_bar %}
{% endblock filter_bar %}

{% block detail_view %}
    <form method="post" accept-charset="utf-8" action="">
        <div class="span3">
            {% include "form_field_snippet.html" with field=form.sales_order %}
            {% include "form_field_snippet.html" with field=form.reference %}
            {% include "form_field_snippet.html" with field=form.confirmation %}
        </div>
        <div class="span9">
            <ul class="nav nav-tabs">
                <li class="active"><a href="#tab1" data-toggle="tab">{% trans "Products" %}</a></li>
                <li><a href="#tab2" data-toggle="tab">{% trans "Dispatch" %}</a></li>
            </ul>
            <div class="tab-content">
                {% csrf_token %}
                {{ formset.management_form }}
                <div class="tab-pane active" id="tab1">
                    <table class="table">
                        <thead>
                            <tr>
                                <th>{% trans "Code" %}</th>
                                <th>{% trans "Product" %}</th>
                                <th>{% trans "Reference" %}</th>
                                <th>{% trans "Amount" %}</th>
                                <th>{% trans "Purchase Price" %}</th>
                            {% if not order.submitted_at %}
                                <th>{% trans "Delete" %}</th>
                            {% else %}
                                <th></th>
                            {% endif %}
                            </tr>
                        </thead>
                        <tbody>
                        {% for form in formset %}
                            {{ form.id }}
                            {{ form.product }}
                            <tr>
                                <td>{{ form.code }}</td>
                                <td>{{ form.title }}</td>
                                <td>{{ form.reference }}</td>
                                <td>{{ form.amount }}</td>
                                <td>{{ form.price }}</td>
                            {% if not order.submitted_at %}
                                <td>{{ form.DELETE }}</td>
                            {% else %}
                                <td></td>
                            {% endif %}
                            </tr>
                        {% empty %}
                            <tr>
                                <td colspan="6" class="muted empty">{% trans "Order does not contain any products" %}</td>
                            </tr>
                        {% endfor %}
                        </tbody>
                        <tfoot>
                            <tr>
                                <td colspan="3" style="text-align:right">{% trans "Total" %}:</td>
                                <td>{{ order.amount }}</td>
                                <td>{{ order.sum|currency }}</td>
                                <td></td>
                            </tr>
                        </tfoot>
                    </table>
                </div>
                <div class="tab-pane" id="tab2">
                    {% include "form_field_snippet.html" with field=form.carrier %}
                    {% include "form_field_snippet.html" with field=form.supplier %}
                    {% include "form_field_snippet.html" with field=form.tracking_id %}
                    {% include "form_field_snippet.html" with field=form.days_delivered %}
                </div>
            </div>
        {% if not order.submitted_at %}
            <div class="form-actions">
                <label class="checkbox pull-left">
                    <input type="checkbox" name="confirm" id="id_confirm"> {% trans "Confirm" %}
                </label>
                <div class="pull-right"><button type="submit" class="btn btn-primary" id="save-bulk-return" data-placeholder="{% trans "Submit" %}">{% trans "Save" %}</button></div>
            </div>
        {% endif %}
    </div>
  </form>
{% endblock detail_view %}

servo/templates/purchases/list_pos.html
{% extends "default.html" %}
{% load servo_tags %}
{% load i18n %}

{% block toolbar %}
<div class="btn-group">
  <a href="{% url 'purchases-create_po' %}" class="btn"><i class="icon-plus"></i> {% trans "New" %}</a>
</div>
{% endblock toolbar %}

{% block content %}

<div class="row-fluid row-header">
  <div class="span12">
    <form class="form-search pull-right">
      
    </form>
  </div>
</div>

{% include "products/tabs.html" %}

{% block filter_bar %}
<div class="row-fluid">
  <div class="span12 well">
    <form action="" method="post" class="form-inline">
      {% csrf_token %}
      {% for field in form %}
      <div class="control-group pull-left">
        <label class="control-label">{{ field.label }}</label>
        <div class="controls">{{ field }}</div>
      </div>
      {% endfor %}
      <div class="control-group">
        <label class="control-label">&nbsp;</label>
        <div class="controls">
          <button class="btn btn-primary pull-right" type="submit"><i class="icon-search icon-white"></i> {% trans "Search" %}</button>
        </div>
      </div>
    </form>
  </div>
</div>
{% endblock filter_bar %}

<div class="row-fluid">
  <div class="span12">
    {% block detail_view %}
    <table class="table table-hover">
      <thead>
        <tr>
          <th>#</th>
          <th>{% trans "Created" %}</th>
          <th>{% trans "Ordered" %}</th>
          <th>{% trans "Reference" %}</th>
          <th>{% trans "Confirmation" %}</th>
          <th>{% trans "Received" %}</th>
          <th>{% trans "Order" %}</th>
          <th>{% trans "Products" %}</th>
          <th>{% trans "Total" %}</th>
          <th></th>
        </tr>
      </thead>
      <tbody>
      {% for po in orders %}
        <tr>
          <td><a href="{{ po.get_absolute_url }}">{{ po.id|safe }}</a></td>
          <td>{{ po.created_at|date:"SHORT_DATE_FORMAT" }}</td>
          <td>{{ po.submitted_at|date:"SHORT_DATE_FORMAT" }}</td>
          <td>{{ po.reference|default:"" }}</td>
          <td>{{ po.confirmation|default:"" }}</td>
          <td>{{ po.date_arrived }}</td>
          {% if po.sales_order %}
          <td><a href="{% url 'orders-edit' po.sales_order.pk %}">{{ po.sales_order.code }}</a></td>
          {% else %}
          <td></td>
          {% endif %}
          <td>{{ po.amount }}</td>
          <td>{{ po.sum|currency }}</td>
          <td>
            <div class="btn-group pull-right">
              <a class="btn dropdown-toggle" data-toggle="dropdown" href="#">
                <i class="icon-cog"></i> <span class="caret"></span>
              </a>
              <ul class="dropdown-menu">
                {% if po.can_create_gsx_stock %}
                <li><a href="{% url 'purchases-submit_stock_order' po.id %}" data-modal="#modal">{% trans "Create GSX Stocking Order" %}</a></li>
                {% else %}
                <li class="disabled"><a href="#">{% trans "Create GSX Stocking Order" %}</a></li>
                {% endif %}
                <li class="divider"></li>
                {% if perms.servo.change_purchaseorder and po.is_editable %}
                <li><a href="{{ po.get_absolute_url }}">{% trans "Edit" %}</a></li>
                {% else %}
                <li class="disabled"><a href="#">{% trans "Edit" %}</a></li>
                {% endif %}
                {% if perms.servo.delete_purchaseorder and po.is_editable %}
                <li><a href="{% url 'purchases-delete_po' po.id %}">{% trans "Delete" %}</a></li>
                {% else %}
                <li class="disabled"><a href="#">{% trans "Delete" %}</a></li>
                {% endif %}
              </ul>
            </div>
          </td>
        </tr>
      {% empty %}
        <tr><td colspan="10" class="empty muted">{% trans "No Purchase Orders" %}</td></tr>
      {% endfor %}
      </tbody>
      <tfoot>
        <tr>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
          <td><strong>{{ total.total__sum|currency|default:"" }}</strong></td>
          <td></td>
        </tr>
      </tfoot>
    </table>
    {% include "pagination.html" with items=orders %}
    {% endblock detail_view %}
  </div>
</div>
{% endblock content %}

{% block crumbs %}
<li><a href="{% url 'purchases-list_pos' %}">{% trans "Purchase Orders" %}</a></li>
{% endblock crumbs %}

servo/templates/purchases/order_stock.html
{% extends "modal.html" %}
{% load i18n %}

{% block header %}
    {% trans "Submit this stocking order?" %}    
{% endblock header %}

{% block body %}
    {% trans "Products will be ordered from GSX." %}
{% endblock body %}

{% block footer %}
    <form action="{{ action }}" method="post">
        {% csrf_token %}
        <button class="btn btn-danger">{% trans "Submit" %}</button>
    </form>
{% endblock footer %}

servo/templates/purchases/view_po.html
{% extends "purchases/edit_po.html" %}
{% load servo_tags %}
{% load i18n %}

{% block toolbar %}
{% endblock toolbar %}

{% block filter_bar %}
{% endblock filter_bar %}

{% block detail_view %}
<div class="row">
  <div class="span4">
    <dl class="dl-horizontal">
      <dt>{% trans "Created By" %}</dt>
      <dd>{{ po.created_by }}</dd>
      <dt>{% trans "Created At" %}</dt>
      <dd>{{ po.created_at|date:"SHORT_DATE_FORMAT" }}</dd>
      <dt>{% trans "Sales Order" %}</dt>
      <dd>{{ po.sales_order|default:"" }}</dd>
      <dt>{% trans "Reference" %}</dt>
      <dd>{{ po.reference }}</dd>
      <dt>{% trans "Confirmation" %}</dt>
      <dd>{{ po.confirmation }}</dd>
    </dl>
  </div>
  <div class="span8">
    <table class="table">
      <thead>
        <tr>
          <th>{% trans "Product" %}</th>
          <th>{% trans "Reference" %}</th>
          <th>{% trans "Amount" %}</th>
          <th>{% trans "Purchase Price" %}</th>
          <th>{% trans "Received At" %}</th>
        </tr>
      </thead>
      <tbody>
      {% for i in products %}
        <tr>
          <td><strong>{{ i.code }}</strong><br/>{{ i.title }}</td>
          <td>{{ i.reference }}</td>
          <td>{{ i.amount }}</td>
          <td>{{ i.price|currency }}</td>
          <td>{{ i.received_at|date:"SHORT_DATE_FORMAT"|default:"-" }}</td>
        </tr>
      {% endfor %}
      </tbody>
    </table>
  </div>
</div>
{% endblock detail_view %}

{% block crumbs %}
  <li><a href="{% url 'purchases-list_pos' %}">{% trans "Purchase Orders" %}</a></li>
{% endblock crumbs %}